﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml.Serialization;
using System.IO;
using System.Xml;
using System.Net;

using REST;
using REST.BES_Namespace;
using REST.BESAPI_Namespace;

namespace RestAPI_Samples
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //==========================================
            //Create SingleAction Object
            SingleAction a = new SingleAction();
            a.Title = "test action";
            
            a.ActionScript = new ActionScript();
            a.ActionScript.Value = "//put actionscript here";
            a.ActionScript.MIMEType = "application/x-Fixlet-Windows-Shell";  //BES Action Script
                                    
            a.Relevance = new RelevanceString();
            a.Relevance.Value = "true";
            
            a.Target = new BESActionTarget();
            a.Target.Items = new object[] { true };
            a.Target.ItemsElementName = new REST.BES_Namespace.ItemsChoiceType[]{ REST.BES_Namespace.ItemsChoiceType.AllComputers };
            //==========================================


            //Create BES Object and add above objects
            BES bes = new BES();
            bes.Items = new object[]{ a };
            
            bes.ItemsElementName = new ItemsChoiceType2[]{ ItemsChoiceType2.SingleAction };
            bes.SkipUI = true;
            bes.SkipUISpecified = true;

            RESTResult rr = RESTAPI.postREST(apiURL.Text + "/api/actions", apiUsername.Text, apiPassword.Text, bes);
            if (rr.isError)
                MessageBox.Show(rr.ErrorMessage);

            button6_Click(sender, e);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int actionID = int.Parse(listView1.SelectedItems[0].Tag.ToString());

            RESTResult rr = RESTAPI.postREST(apiURL.Text + "/api/action/" + actionID.ToString() + "/stop", apiUsername.Text, apiPassword.Text, null);
            if (rr.isError)
                MessageBox.Show(rr.ErrorMessage);

            //now refresh actions list
            button6_Click(sender, e);
        }


        private void button3_Click(object sender, EventArgs e)
        {
            int actionID = int.Parse(listView2.SelectedItems[0].Tag.ToString());

            RESTResult rr = RESTAPI.deleteREST(apiURL.Text + "/api/action/" + actionID.ToString(), apiUsername.Text, apiPassword.Text);
            if (rr.isError)
                MessageBox.Show(rr.ErrorMessage);

            //now refresh actions list
            button6_Click(sender, e);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            RESTResult rr = RESTAPI.getREST(apiURL.Text + tb_get.Text, apiUsername.Text, apiPassword.Text);
            if (rr.isError)
            {
                MessageBox.Show(rr.ErrorMessage);
                return;
            }


            tb_Results.Text = rr.result;
            if (rr.bes == null)
                tb_bes.Text = "null";
            else tb_bes.Text = "not null";
            if (rr.besapi == null)
                tb_besapi.Text = "null";
            else tb_besapi.Text = "not null";

            if (rr.isError)
                MessageBox.Show(rr.ErrorMessage);
        }

        

        private void button6_Click(object sender, EventArgs e)
        {
            RESTResult rr = RESTAPI.getREST(apiURL.Text + "/api/actions", apiUsername.Text, apiPassword.Text);
            if (rr.isError)
            {
                MessageBox.Show(rr.ErrorMessage);
                return;
            }

            listView1.Items.Clear();
            foreach (object obj in rr.besapi.Items)
            {
                ListViewItem lvi = new ListViewItem();
                lvi.Text = ((BESAPIAction)obj).Name;
                lvi.Tag = ((BESAPIAction)obj).ID;
                listView1.Items.Add(lvi);
            }
            listView1.Refresh();

            listView2.Items.Clear();
            foreach (object obj in rr.besapi.Items)
            {
                ListViewItem lvi = new ListViewItem();
                lvi.Text = ((BESAPIAction)obj).Name;
                lvi.Tag = ((BESAPIAction)obj).ID;
                listView2.Items.Add(lvi);
            }
            listView2.Refresh();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            button6_Click(sender, e);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            RESTResult rr = RESTAPI.getREST(apiURL.Text + "/api/analyses/master", apiUsername.Text, apiPassword.Text);
            if (rr.isError)
            {
                MessageBox.Show(rr.ErrorMessage);
                return;
            }

            listView3.Items.Clear();
            foreach (object obj in rr.besapi.Items)
            {
                ListViewItem lvi = new ListViewItem();
                lvi.Text = ((BESAPIAnalysis)obj).Name;
                lvi.Tag = ((BESAPIAnalysis)obj).ID;
                listView3.Items.Add(lvi);
            }
            listView3.Refresh();
        }

       

        private void button5_Click(object sender, EventArgs e)
        {
            int analysisID = int.Parse(textBox1.Tag.ToString());

            //Retrieve an existing analysis
            RESTResult rr = RESTAPI.getREST(apiURL.Text + "/api/analysis/master/" + analysisID.ToString(), apiUsername.Text, apiPassword.Text);
            if (rr.isError)
            {
                MessageBox.Show(rr.ErrorMessage);
                return;
            }

            //pull it out so our code is simplier
            Analysis a = (Analysis)rr.bes.Items[0];

            a.Title = textBox1.Text;
            
            ////create a new property
            //AnalysisProperty ap = new AnalysisProperty();
            //ap.ID = "3";
            //ap.Name = "Operating System";
            //ap.EvaluationPeriod = ActionReapplyInterval.P30D.ToString();
            //ap.Value = "name of operating system";

            ////append to this Analysis' Properties list
            //a.Property = RESTAPI.AddItemToArray(a.Property, ap);

            //make call to update analysis
            rr = RESTAPI.putREST(apiURL.Text + "/api/analysis/master/" + analysisID.ToString(), apiUsername.Text, apiPassword.Text, rr.bes);
            if (rr.isError)
                MessageBox.Show(rr.ErrorMessage);

            button8_Click(sender, e);
        }

        private void listView3_SelectedIndexChanged(object sender, EventArgs e)
        {
            textBox1.Text = listView3.SelectedItems[0].Text;
            textBox1.Tag = listView3.SelectedItems[0].Tag;
        }




    }
}
